/*	
 *	framldir.c
 *
 *	ؑցE16K\
 *
 *	CLiP - Common Library for P/ECE
 *	Copyright (C) 2001-2004 Naoyuki Sawa
 *
 *	* Sun Jun 6 14:11:00 JST 2004 Naoyuki Sawa
 *	- 쐬JnB
 *	* Tue Jun 8 19:00:00 JST 2004 Naoyuki Sawa
 *	- 4bit`̂߂̃JX^pceLCDDrawObject()̃W[Ɋ܂߂܂B
 *	* Thu Jun 10 19:00:00 JST 2004 Naoyuki Sawa
 *	- new_pceLCDTrans()̏{̂RAMֈڂAldirect_mkbuf()Ƃ܂B
 */
#include "clip.h"

/****************************************************************************
 *	֐
 ****************************************************************************/

#if 0	/*==================================================================*/
void
ldirect_mkbuf(const unsigned char wbuff[/*DISP_X / 2 * DISP_Y*/], const unsigned char* lcdbuff)
{
	const unsigned int* src = (const unsigned int*)lcdbuff;
	      unsigned int* dst = (      unsigned int*)wbuff;
	//
	int i;
	unsigned int pixel0to3;
	unsigned int pixel4to7;

	/* 8sNZPʂŁAs4sNZ4bitA㑱4sNZ4bitɏd˂Ċi[܂B */
	for(i = 0; i < DISP_X / 8 * DISP_Y; i++) {
		pixel0to3 = *src++;
		pixel4to7 = *src++;
		*dst++ = pixel0to3 << 4 | pixel4to7;
	}
}
#else	/*==================================================================*/
asm("
	.code
	.global ldirect_mkbuf
ldirect_mkbuf:
	xld.w %r15, 1408		; %r15 = DISP_X / 8 * DISP_Y
ldirect_mkbuf_LOOP:
	ld.w %r10, [%r13]+		; %r10 = pixel0to3
	ld.w %r11, [%r13]+		; %r11 = pixel4to7
	xsll %r10, 4			; %r10 = pixel0to3 << 4 | pixel4to7
	or %r10, %r11
	ld.w [%r12]+, %r10		; store (pixel0to3 << 4 | pixel4to7)
	xsub %r15, %r15, 1
	xjrne ldirect_mkbuf_LOOP
	ret
");
#endif	/*==================================================================*/

#if 0	/*==================================================================*/
void
ldirect_trans(const unsigned char wbuff[/*DISP_X / 2 * DISP_Y*/], const unsigned short cvttbl[/*256*/])
{
	/* R[hTCYߖ&̂߂ɁAI/Ö̃x[XAhX[Jϐɗpӂ܂B */
	#undef plc_IO /* c33209.hł̃}N`LZ */
	volatile struct c_IOtag* plc_IO = (volatile struct c_IOtag*)0x40000;

	int v;
	int page;
	int column;

	/* ey[W(8~c88(=DISP_Y)sNZ̒Z`)]܂B
	 * * P/ECE LCD̃y[Wԍт́A { 9,8,7,6,5,4,3,2,1,0,15,14,13,12,11,10 } łB
	 *   JɎgĂLCDƂ̌݊̂߂̗jIR(H)ɂA
	 *   LCDn[hEFA猩ƁAE]{9y[WXN[ԂƂȂĂ܂B
	 *   /usr/PIECE/sysdev/pcekn/lcd.cQƂĂB
	 */
	page = 9;
	do {

		/*** R}hM ***/

		bP2_P2D_P21D = 0; /* RS <= 0:Command */

		v = 0xb0 | page; /* Set Page Address */
		asm volatile ("mirror %0,%0" : "=r"(v) : "0"(v));
		while(!bSIF3_STATUS_TDBE3) { /* Mobt@󂫑҂ */ }
		pSIF3_TXD = v;

		//v = 0x10; /* Set Column Address MSB */
		//asm volatile ("mirror %0,%0" : "=r"(v) : "0"(v));
		//0x10mirror͂炩ߌvZł̂ŁÂ悤ɕύXB
		v = 0x08;
		while(!bSIF3_STATUS_TDBE3) { /* Mobt@󂫑҂ */ }
		pSIF3_TXD = v;

		//v = 0x00; /* Set Column Address LSB */
		//asm volatile ("mirror %0,%0" : "=r"(v) : "0"(v));
		//0x00mirror͂炩ߌvZł̂ŁÂ悤ɕύXB
		v = 0x00;
		while(!bSIF3_STATUS_TDBE3) { /* Mobt@󂫑҂ */ }
		pSIF3_TXD = v;

		while(bSIF3_STATUS_TEND3) { /* M҂ */ } /* Kv!! */

		/*** f[^M ***/

		bP2_P2D_P21D = 1; /* RS <= 1:Data */

		for(column = 0; column < DISP_Y; column++) {
			v =          cvttbl[*wbuff++]; /* [4],[0] */
			v = v >> 1 | cvttbl[*wbuff++]; /* [5],[1] */
			v = v >> 1 | cvttbl[*wbuff++]; /* [6],[2] */
			v = v >> 1 | cvttbl[*wbuff  ]; /* [7],[3] */
			wbuff += (DISP_X / 2) - (8 / 2 - 1);

			while(!bSIF3_STATUS_TDBE3) { /* Mobt@󂫑҂ */ }
			pSIF3_TXD = v;
			while(!bSIF3_STATUS_TDBE3) { /* Mobt@󂫑҂ */ }
			pSIF3_TXD = v >> 8;
		}

		/* ̃y[WցB */
		wbuff += (8 / 2) - (DISP_X / 2 * DISP_Y);
		page = (page - 1) & 15;

		while(bSIF3_STATUS_TEND3) { /* M҂ */ } /* Kv!! */

	} while(page != 9); /* y[WԍI */
}
#else	/*==================================================================*/
asm("
	.code
	.global ldirect_trans
ldirect_trans:
	xld.w %r4, 0x401f5		; %r4 = pSIF3_TXD
	xld.w %r5, 0x401f7		; %r5 = pSIF3_STATUS
	xld.w %r6, 0x402d9		; %r6 = pP2_P2D
	;
	xld.w %r14, 9			; %r14 = page = { 9,8,7,6,5,4,3,2,1,0,15,14,13,12,10 }
ldirect_trans_LOOP_X:
	;
	;	R}hM
	;
	bclr [%r6], 1			; bP2_P2D_P21D = 0
	;
	mirror %r10, %r14		; %r10 = mirror(0xb0 | page)
	xoor %r10, %r10, 0x0d		;      = 0x0d | mirror(page)
ldirect_trans_L10:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	xjreq ldirect_trans_L10
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	xld.w %r10, 0x08		; %r10 = mirror(0x10) = 0x08
ldirect_trans_L20:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	xjreq ldirect_trans_L20
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	xld.w %r10, 0x00		; %r10 = mirror(0x00) = 0x00
ldirect_trans_L30:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	xjreq ldirect_trans_L30
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
ldirect_trans_L40:
	btst [%r5], 5			; while(bSIF3_STATUS_TEND3) { }
	xjrne ldirect_trans_L40
	;
	;	f[^M
	;
	bset [%r6], 1			; bP2_P2D_P21D = 1
	;
	xld.w %r15, 88			; %r15 = DISP_Y
ldirect_trans_LOOP_Y:
	;
	; ȉ̖ߗAC^[bN悤ƂăWX^蓖Ă̕ύX▽߂̕ёւsƁA
	;   Ȃ]vɒxȂ܂BĂȂAOANZXp^[̓ł傤H
	;   Ƃ肠̂܂܂ŁEEE
	;
	ld.ub %r11, [%r12]+		; [4],[0]
	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r10, [%r11]
	;
	ld.ub %r11, [%r12]+		; [5],[1]
	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r11, [%r11]
	xsrl %r10, 1			; *anti-interlock*
	or %r10, %r11
	;
	ld.ub %r11, [%r12]+		; [6],[2]
	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r11, [%r11]
	xsrl %r10, 1			; *anti-interlock*
	or %r10, %r11
	;
	ld.ub %r11, [%r12]		; [7],[3]
	xsll %r11, 1			; !INTERLOCK!
	add %r11, %r13
	ld.uh %r11, [%r11]
	xsrl %r10, 1			; *anti-interlock*
	or %r10, %r11
	;
ldirect_trans_L50:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	xjreq ldirect_trans_L50
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	xadd %r12, %r12, 61		; %r12 += (DISP_X / 2) - (8 / 2 - 1)
	xsrl %r10, 8			; %r10 >>= 8
	;
ldirect_trans_L60:
	btst [%r5], 1			; while(!bSIF3_STATUS_TDBE3) { }
	xjreq ldirect_trans_L60
	ld.b [%r4], %r10		; pSIF3_TXD = %r10
	;
	xsub %r15, %r15, 1
	xjrne ldirect_trans_LOOP_Y
	;
	xsub %r12, %r12, 5628		; wbuff += (8 / 2) - (DISP_X / 2 * DISP_Y)
	xsub %r14, %r14, 1		; page = (page - 1) & 15
	xand %r14, %r14, 15
	;
ldirect_trans_L70:
	btst [%r5], 5			; while(bSIF3_STATUS_TEND3) { }
	xjrne ldirect_trans_L70
	;
	xcmp %r14, 9
	xjrne ldirect_trans_LOOP_X
	;
	ret
");
#endif	/*==================================================================*/

/****************************************************************************
 *	pceLCDDrawObject() 4bit`T|[g
 ****************************************************************************/

/* clipldir.cnew_pceLCDDrawObject()Ăяo܂B
 * * NbsÓAĂяoOnew_pceLCDDrawObject()ɂĊĂ܂B
 * * DRAW_OBJECT.dest́Anew_LCDDrawObject()ɂĊmɗLlɐݒ肳Ă܂B
 *   PDW_Draw_4BN()ł́ADRAW_OBJECT.dest̋Kl擾鏈sKv͂܂B
 */
void
PDW_Draw_4BN(DRAW_OBJECT obj)
{
	int n, x, y, step, dest_stride, src_stride;
	unsigned char *dest_buf, *src_mask, mask;
	unsigned int *src_buf, pixel;

	/* ]_A]摜̐8sNZPʂ̂sNZڂJn邩H */
	step = obj.sx & 7;

	/* ]sNZAhX߂܂B */
	n = (obj.src->header.w * obj.sy + obj.sx) / 8;
	src_buf = (unsigned int*)obj.src->buf + n;
	src_mask = obj.src->mask + n;
	src_stride = obj.src->header.w / 8 - (step + obj.dw - 1) / 8;
	/*                                                  ~~~         */
	/* 8Xebvɐiނ̂ł͂ȂA9Xebvڂ̐擪Őiނ */

	/* c]CpӂĂ܂B */
	y = obj.dh;

	/* ]ɂāA𕪂܂B(DRW_NOMAL=0Ɖ)
	 * ]ȊÕtOw肳ĂA{ɔC܂B
	 */
	switch(obj.param) {
	case 0/*]Ȃ*/:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * obj.dy + obj.dx;
		dest_stride = obj.dest->w - obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_00: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf++; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_00;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_01: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf++ = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_01;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;

	case DRW_REVX:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * obj.dy + obj.dx + obj.dw - 1;
		dest_stride = obj.dest->w + obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_10: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf--; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_10;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_11: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf-- = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_11;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;

	case DRW_REVY:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * (obj.dy + obj.dh - 1) + obj.dx;
		dest_stride = -obj.dest->w - obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_20: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf++; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_20;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_21: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf++ = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_21;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;

	case DRW_REVX | DRW_REVY:
		/* ]sNZAhX߂܂B */
		dest_buf = obj.dest->buf + obj.dest->w * (obj.dy + obj.dh - 1) + obj.dx + obj.dw - 1;
		dest_stride = -obj.dest->w + obj.dw;

		if(obj.src->header.mask) {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */
				mask = *src_mask;	/* sNZт MSB:01234567:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_30: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
					mask = *++src_mask;
#define PIXEL(p, m) \
					/* ssNZȂA`܂B */ \
					if(mask & (1 << (m))) *dest_buf = pixel >> (p) * 4 & 15; \
					dest_buf--; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1, 7);
				case 1:       PIXEL(0, 6);
				case 2:       PIXEL(3, 5);
				case 3:       PIXEL(2, 4);
				case 4:       PIXEL(5, 3);
				case 5:       PIXEL(4, 2);
				case 6:       PIXEL(7, 1);
				default/*7*/: PIXEL(6, 0); goto LOOP_30;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
				src_mask += src_stride;
			} while(--y != 0);
		} else {
			do {
				/* Jn_n܂邩rn܂邩킩Ȃ̂ŁA
				 * ͂Ƃstep=0łAōŏ̃f[^擾邱Ƃɂ܂B
				 */
				pixel = *src_buf;	/* sNZт MSB:67452301:LSB ̏ł */

				/* c萅sNZ擾܂B */
				x = obj.dw;

				/* sNZڂJn邩ɂāAK؂Ȉʒu֔э݂܂B */
				switch(step) {
LOOP_31: /* ͔͂щz܂ */
					/* 8sNZPʂ̊Jn_ŁÃf[^擾܂B */
					pixel = *++src_buf;
#define PIXEL(p) \
					/* sNZA`܂B */ \
					*dest_buf-- = pixel >> (p) * 4 & 15; \
					/* 1C]A܂B */ \
					if(--x == 0) break;
				case 0:       PIXEL(1);
				case 1:       PIXEL(0);
				case 2:       PIXEL(3);
				case 3:       PIXEL(2);
				case 4:       PIXEL(5);
				case 5:       PIXEL(4);
				case 6:       PIXEL(7);
				default/*7*/: PIXEL(6); goto LOOP_31;
#undef PIXEL
				}

				/* ]E]sNZAhX̃C֐i߂܂B */
				dest_buf += dest_stride;
				src_buf += src_stride;
			} while(--y != 0);
		}
		break;
	}
}

